%global pypi_name horizon

Summary:        OpenStack Dashboard (Horizon)
Name:           openstack-dashboard
Version:        19.2.0
Release:        2%{?dist}
License:        Apache-2.0 and BSD
URL:            http://horizon.openstack.org/
Source0:        %pypi_source
Source1:        openstack-dashboard-httpd-2.4.conf
Source2:        openstack-dashboard-systemd.conf
Source3:        openstack-dashboard-logrotate.conf

BuildArch:      noarch

BuildRequires:  python3-devel python3-setuptools python3-pbr python3-osprofiler
BuildRequires:  python3-iso8601 python3-pycodestyle python3-mock python3-netaddr
BuildRequires:  git-core gettext
Requires:       python3-%{pypi_name} python3-openstack_auth

%description
The OpenStack dashboard provides administrators and users a graphical
interface to access, provision and automate cloud-based resources. The
extensible design makes it easy to plug in and expose third party
products and services, such as billing, monitoring and additional
management tools.

%package -n python3-openstack_auth
Summary:        OpenStack Auth (Horizon) - Python Module
Provides:       python-openstack_auth

%description -n python3-openstack_auth
The Python module OpenStack Auth provides Authentication mechanism
for the OpenStack Dashboard (Horizon).

%package -n python3-%{pypi_name}
Summary:        Openstack web user interface reference implementation
BuildRequires:  python3-babel python3-debtcollector python3-iso8601 python3-keystoneauth1 python3-futurist
BuildRequires:  python3-django python3-django-pyscss python3-django-debreach python3-django-compressor
BuildRequires:  python3-netaddr python3-osprofiler python3-pymongo python3-scss
BuildRequires:  python3-cinderclient python3-glanceclient python3-keystoneclient
BuildRequires:  python3-novaclient python3-neutronclient python3-swiftclient
BuildRequires:  python3-oslo-concurrency python3-oslo-config python3-oslo-i18n python3-oslo-policy
BuildRequires:  python3-oslo-serialization python3-oslo-utils python3-oslo-upgradecheck
BuildRequires:  python3-XStatic-Angular python3-XStatic-Angular-Bootstrap python3-XStatic-Angular-Schema-Form
BuildRequires:  python3-XStatic-Angular-Gettext python3-XStatic-Angular-FileUpload python3-XStatic-Angular-lrdragndrop
BuildRequires:  python3-XStatic python3-XStatic-D3 python3-XStatic-Hogan python3-XStatic-Font-Awesome
BuildRequires:  python3-XStatic-JSEncrypt python3-XStatic-Jasmine python3-XStatic-termjs python3-XStatic-smart-table
BuildRequires:  python3-XStatic-Bootstrap-SCSS python3-XStatic-Bootstrap-Datepicker python3-XStatic-bootswatch
BuildRequires:  python3-XStatic-roboto-fontface python3-XStatic-mdi python3-XStatic-objectpath python3-XStatic-tv4
BuildRequires:  python3-XStatic-jQuery python3-XStatic-JQuery-Migrate python3-XStatic-JQuery-TableSorter
BuildRequires:  python3-XStatic-JQuery-quicksearch python3-XStatic-jquery-ui python3-XStatic-Rickshaw
BuildRequires:  python3-XStatic-Spin python-XStatic-objectpath python-XStatic-roboto-fontface
BuildRequires:  python3-requests python3-yaml python3-semantic_version
BuildRequires:  python3-scss python3-pytz python3-memcached python3-pytest
BuildRequires:  systemd fontawesome-fonts-web
Requires:       python3-babel python3-debtcollector python3-iso8601 python3-keystoneauth1 python3-futurist
Requires:       python3-django python3-django-pyscss python3-django-debreach python3-django-compressor
Requires:       python3-netaddr python3-osprofiler python3-pymongo python3-scss
Requires:       python3-cinderclient python3-glanceclient python3-keystoneclient
Requires:       python3-novaclient python3-neutronclient python3-swiftclient
Requires:       python3-oslo-concurrency python3-oslo-config python3-oslo-i18n python3-oslo-policy
Requires:       python3-oslo-serialization python3-oslo-utils python3-oslo-upgradecheck
Requires:       python3-XStatic-Angular python3-XStatic-Angular-Bootstrap python3-XStatic-Angular-Schema-Form
Requires:       python3-XStatic-Angular-Gettext python3-XStatic-Angular-FileUpload python3-XStatic-Angular-lrdragndrop
Requires:       python3-XStatic python3-XStatic-D3 python3-XStatic-Hogan python3-XStatic-Font-Awesome
Requires:       python3-XStatic-JSEncrypt python3-XStatic-Jasmine python3-XStatic-termjs python3-XStatic-smart-table
Requires:       python3-XStatic-Bootstrap-SCSS python3-XStatic-Bootstrap-Datepicker python3-XStatic-bootswatch
Requires:       python3-XStatic-roboto-fontface python3-XStatic-mdi python3-XStatic-objectpath python3-XStatic-tv4
Requires:       python3-XStatic-jQuery python3-XStatic-JQuery-Migrate python3-XStatic-JQuery-TableSorter
Requires:       python3-XStatic-JQuery-quicksearch python3-XStatic-jquery-ui python3-XStatic-Rickshaw
Requires:       python3-XStatic-Spin python-XStatic-objectpath python-XStatic-roboto-fontface
Requires:       python3-requests python3-yaml python3-semantic_version
Requires:       python3-memcached python3-mod_wsgi
Requires:       fontawesome-fonts-web openssl logrotate

%description -n python3-%{pypi_name}
Openstack Dashboard is a web user interface for Openstack. The package
provides a reference implementation using the Django Horizon project,
mostly consisting of JavaScript and CSS to tie it altogether as a standalone
site.
This package contains the python library.

%prep
%autosetup -n %{pypi_name}-%{version} -S git

sed -i "/^DEBUG =.*/c\DEBUG = False" openstack_dashboard/local/local_settings.py.example
sed -i "/^WEBROOT =.*/c\WEBROOT = '/dashboard/'" openstack_dashboard/local/local_settings.py.example
sed -i "/^.*ALLOWED_HOSTS =.*/c\ALLOWED_HOSTS = ['horizon.example.com', 'localhost']" openstack_dashboard/local/local_settings.py.example
sed -i "/^.*LOCAL_PATH =.*/c\LOCAL_PATH = '/tmp'" openstack_dashboard/local/local_settings.py.example
sed -i "/^.*POLICY_FILES_PATH =.*/c\POLICY_FILES_PATH = '/etc/openstack-dashboard'" openstack_dashboard/local/local_settings.py.example

sed -i "/^BIN_DIR = .*/c\BIN_DIR = '/usr/bin'" openstack_dashboard/settings.py
sed -i "/^COMPRESS_PARSER = .*/a COMPRESS_OFFLINE = True" openstack_dashboard/settings.py
sed -i 's:COMPRESS_OFFLINE.=.False:COMPRESS_OFFLINE = True:' openstack_dashboard/settings.py

# Fix Python shebang in manage.py
sed -i 's/\/usr\/bin\/env python/\/usr\/bin\/env python3/' manage.py

%build
cd horizon && django-admin compilemessages && cd ..
cd openstack_dashboard && django-admin compilemessages && cd ..

# Regenerate complete SOURCES.txt
echo >> horizon.egg-info/SOURCES.txt
ls */locale/*/LC_MESSAGES/django*mo >> horizon.egg-info/SOURCES.txt

%{py3_build}

cp openstack_dashboard/local/local_settings.py.example openstack_dashboard/local/local_settings.py
%{__python3} manage.py collectstatic --noinput --clear
%{__python3} manage.py compress --force

# recopy to undo hack
cp openstack_dashboard/local/local_settings.py.example openstack_dashboard/local/local_settings.py

%install
%{py3_install}
install -m 0644 -D -p %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/openstack-dashboard.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/openstack-dashboard
install -d -m 755 %{buildroot}%{_datadir}/openstack-dashboard
install -d -m 755 %{buildroot}%{_sharedstatedir}/openstack-dashboard

mkdir -p %{buildroot}%{_unitdir}/httpd.service.d/
cp %{SOURCE2} %{buildroot}%{_unitdir}/httpd.service.d/openstack-dashboard.conf

mv %{buildroot}%{python3_sitelib}/openstack_dashboard %{buildroot}%{_datadir}/openstack-dashboard
cp manage.py %{buildroot}%{_datadir}/openstack-dashboard
rm -rf %{buildroot}%{python3_sitelib}/openstack_dashboard

find %{buildroot} -name django.po -exec rm '{}' \;
find %{buildroot} -name djangojs.po -exec rm '{}' \;

mv %{buildroot}%{_datadir}/openstack-dashboard/openstack_dashboard/local/local_settings.py.example %{buildroot}%{_sysconfdir}/openstack-dashboard/local_settings
mv %{buildroot}%{_datadir}/openstack-dashboard/openstack_dashboard/conf/default_policies %{buildroot}%{_sysconfdir}/openstack-dashboard
mv %{buildroot}%{_datadir}/openstack-dashboard/openstack_dashboard/conf/*.yaml %{buildroot}%{_sysconfdir}/openstack-dashboard
mv %{buildroot}%{_datadir}/openstack-dashboard/openstack_dashboard/conf/nova_policy.d %{buildroot}%{_sysconfdir}/openstack-dashboard
ln -s ../../../../..%{_sysconfdir}/openstack-dashboard/local_settings %{buildroot}%{_datadir}/openstack-dashboard/openstack_dashboard/local/local_settings.py

%find_lang django --all-name

grep "\/usr\/share\/openstack-dashboard" django.lang > dashboard.lang
grep "\/site-packages\/horizon" django.lang > horizon.lang

mkdir -p %{buildroot}%{_datadir}/openstack-dashboard/static
cp -a openstack_dashboard/static/* %{buildroot}%{_datadir}/openstack-dashboard/static
cp -a horizon/static/* %{buildroot}%{_datadir}/openstack-dashboard/static
cp -a static/* %{buildroot}%{_datadir}/openstack-dashboard/static

mkdir -p %{buildroot}%{_sharedstatedir}/openstack-dashboard
mkdir -p %{buildroot}%{_var}/log/horizon
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
cp -a %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-dashboard

%check
rm horizon/test/unit/hacking/test_checks.py
%{__python3} manage.py test horizon --settings=horizon.test.settings

%post -n openstack-dashboard
sed -i "/^from horizon.utils import secret_key$/d" /etc/openstack-dashboard/local_settings
sed -i "/^SECRET_KEY.*$/{N;s/^.*$/SECRET_KEY='`openssl rand -hex 10`'/}" /etc/openstack-dashboard/local_settings
systemctl daemon-reload >/dev/null 2>&1 || :

%postun
systemctl daemon-reload >/dev/null 2>&1 || :

%files -f dashboard.lang
%license LICENSE
%dir %{_datadir}/openstack-dashboard/
%{_datadir}/openstack-dashboard/*.py*
%{_datadir}/openstack-dashboard/static
%dir %{_datadir}/openstack-dashboard/openstack_dashboard
%{_datadir}/openstack-dashboard/openstack_dashboard/*.py*
%{_datadir}/openstack-dashboard/openstack_dashboard/api
%{_datadir}/openstack-dashboard/openstack_dashboard/contrib
%{_datadir}/openstack-dashboard/openstack_dashboard/django_pyscss_fix
%{_datadir}/openstack-dashboard/openstack_dashboard/enabled
%{_datadir}/openstack-dashboard/openstack_dashboard/karma.conf.js
%{_datadir}/openstack-dashboard/openstack_dashboard/local
%{_datadir}/openstack-dashboard/openstack_dashboard/management
%{_datadir}/openstack-dashboard/openstack_dashboard/static
%{_datadir}/openstack-dashboard/openstack_dashboard/templates
%{_datadir}/openstack-dashboard/openstack_dashboard/templatetags
%{_datadir}/openstack-dashboard/openstack_dashboard/themes
%{_datadir}/openstack-dashboard/openstack_dashboard/test
%{_datadir}/openstack-dashboard/openstack_dashboard/usage
%{_datadir}/openstack-dashboard/openstack_dashboard/utils
%{_datadir}/openstack-dashboard/openstack_dashboard/.eslintrc
%{_datadir}/openstack-dashboard/openstack_dashboard/__pycache__
%dir %{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/
%{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/admin
%{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/identity
%{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/project
%{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/settings
%{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/__init__.py*
%{_datadir}/openstack-dashboard/openstack_dashboard/dashboards/__pycache__
%dir %{_datadir}/openstack-dashboard/openstack_dashboard/locale
%dir %{_datadir}/openstack-dashboard/openstack_dashboard/locale/??
%dir %{_datadir}/openstack-dashboard/openstack_dashboard/locale/??_??
%dir %{_datadir}/openstack-dashboard/openstack_dashboard/locale/??/LC_MESSAGES
%dir %{_datadir}/openstack-dashboard/openstack_dashboard/locale/??_??/LC_MESSAGES

%dir %attr(0750, root, apache) %{_sysconfdir}/openstack-dashboard
%dir %attr(0750, apache, apache) %{_sharedstatedir}/openstack-dashboard
%dir %attr(0750, apache, apache) %{_var}/log/horizon
%config(noreplace) %{_sysconfdir}/httpd/conf.d/openstack-dashboard.conf
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/local_settings
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/default_policies/*.yaml
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/default_policies/README.txt
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/cinder_policy.yaml
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/keystone_policy.yaml
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/nova_policy.yaml
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/glance_policy.yaml
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/neutron_policy.yaml
%config(noreplace) %attr(0640, root, apache) %{_sysconfdir}/openstack-dashboard/nova_policy.d/api-extensions.yaml
%config(noreplace) %attr(0644, root, root) %{_sysconfdir}/logrotate.d/openstack-dashboard
%attr(755,root,root) %dir %{_unitdir}/httpd.service.d
%config(noreplace) %{_unitdir}/httpd.service.d/openstack-dashboard.conf

%files -n python3-%{pypi_name}
%license LICENSE
%{python3_sitelib}/horizon
%{python3_sitelib}/horizon-*.egg-info

%files -n python3-openstack_auth
%license LICENSE
%{python3_sitelib}/openstack_auth

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 19.2.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 21 2023 kianli <kianli@tencent.com> - 19.2.0-1
- initial build
